﻿--ver: 2.0a
---AddFriend is reserved by WoW, so to prevent conflicts using AFriend
--Call console for commands, event for click events, Hook for any needed hooks into the dropdowns.
AFriend = LibStub("AceAddon-3.0"):NewAddon("AFriend", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0");
local Afriends = LibStub("LibFriends-1.0");
local AFriend = AFriend;

function AFriend:OnInitialize()
	local versionString = GetAddOnMetadata("AddFriend", "Version");
end

function AFriend:OnEnable()
	self:SecureHook("UnitPopup_ShowMenu");
end

function AFriend:OnDisable()
	self:Unhook("UnitPopup_ShowMenu");
end

function AFriend:UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	local thisName, thisText = "";
	local addFriend = true;
	if(which == "PET" or which == "SELF") then
		return;
	elseif(which ~= "FRIEND" and which ~= "PLAYER" and which ~= "PARTY" and which ~= "RAID_PLAYER" and which ~= "RAID") then
		return;
	end

	if (UIDROPDOWNMENU_MENU_LEVEL > 1) then
		return;
	end

	--TODO: Localizations.
	--TODO: Test if player is in guild and able to invite
	--TODO: EnemyDetection
	thisName = name or UnitName(unit);
	thisText = "Add Friend";
	if(Afriends:IsFriendOnline(thisName)) then
		thisText = "Remove Friend";
		addFriend = false;
	end
	
	local info = UIDropDownMenu_CreateInfo();
		info.text = thisText;
		info.value = nil;
		info.owner = which;
		info.func = AFriend_ContextMenu_OnClick;
		info.notCheckable = true;
		info.arg1 = {["unit"] = unit, ["name"] = name, ["addFriend"] = addFriend};
	UIDropDownMenu_AddButton(info);
end

--TODO: add send them a tell with addon options
function AFriend_ContextMenu_OnClick(self, info)
		assert(info);
		name = info.name or UnitName(info.unit);
		assert(name);
		if (info.addFriend == true) then
			AddFriend(name);
		else
			RemoveFriend(name);
		end
end

function AFriend:ChatFrame_OnEvent(frame, event, ...)
	return self.hooks["ChatFrame_OnEvent"](frame, event, ...);
end